#!/usr/bin/env python
#encoding: utf-8

"""Simulate a keypad via the arrowkeys.

this is done to make the main source file leaner and easier to understand."""

# We need key definitions: 
from pyglet.window import key

def keypad(symbol,  chooser):
    """Select a choice based on the keyboard input. 
    
    chooser is a Thing which can decide based on the keypad input (it needs a choice_buffer() method)."""
    # Just map the symbols to positions. The numeric symbol is necessary for my keypad to work... migth be a bug in pyglet, or just a german keyboard... 
    if symbol == key.NUM_1 or symbol == 65436:
        chooser.choice_buffer(decision=1)
    if symbol == key.NUM_2 or symbol == 65433:
        chooser.choice_buffer(decision=2)
    if symbol == key.NUM_3 or symbol == 65435: 
        chooser.choice_buffer(decision=3)
    if symbol == key.NUM_4 or symbol == 65430: 
        chooser.choice_buffer(decision=4)
    if symbol == key.NUM_4 or symbol == 65437: 
        chooser.choice_buffer(decision=5)
    if symbol == key.NUM_6 or symbol == 65432: 
        chooser.choice_buffer(decision=6)
    if symbol == key.NUM_7 or symbol == 65429: 
        chooser.choice_buffer(decision=7)
    if symbol == key.NUM_8 or symbol == 65431: 
        chooser.choice_buffer(decision=8)
    if symbol == key.NUM_9 or symbol == 65434: 
        chooser.choice_buffer(decision=9)
    # If we get an arrow key, we decide in many steps - this means, we just move the weapon around with teh arrow keys.
    if symbol == key.UP: 
        chooser.choice_buffer(choice="up")
    if symbol == key.DOWN: 
        chooser.choice_buffer(choice="down")
    if symbol == key.LEFT: 
        chooser.choice_buffer(choice="left")
    if symbol == key.RIGHT: 
        chooser.choice_buffer(choice="right")
    if symbol == key.RETURN or symbol == key.ENTER or symbol == 65421: 
        chooser.choice_buffer(save=True)

def choose_in_two_steps(choice,  chooser):
        """Do a two-step choice""" 
	# If we didn't yet assign a value to teh choice_buffer, we do soi, by mapping the arrow keys to positions - this is a direct choice of the position. 
        if chooser.choice_buf is None: 
            if choice == "up": 
                chooser.choice_buf = 8
                chooser.choice_buffer(decision=8)
            elif choice == "down": 
                chooser.choice_buf = 2
                chooser.choice_buffer(decision=2)
            elif choice == "left": 
                chooser.choice_buf = 4
                chooser.choice_buffer(decision=4)
            elif choice == "right": 
                chooser.choice_buf = 6
                chooser.choice_buffer(decision=6)
	# If the choice_buffer already holds a value, we just modify this choice.
	# This moves the weapon around in the 3x3 map of number keys on the keypad.
        elif chooser.choice_buf == 1 and choice == "up": 
            chooser.choice_buf = 4
            chooser.choice_buffer(decision=4)
        elif chooser.choice_buf == 1 and choice == "right": 
            chooser.choice_buf = 2
            chooser.choice_buffer(decision=2)
        elif chooser.choice_buf == 2 and choice == "up": 
            chooser.choice_buf = 5
            chooser.choice_buffer(decision=5)
        elif chooser.choice_buf == 2 and choice == "left": 
            chooser.choice_buf = 1
            chooser.choice_buffer(decision=1)
        elif chooser.choice_buf == 2 and choice == "right": 
            chooser.choice_buf = 3
            chooser.choice_buffer(decision=3)
        elif chooser.choice_buf == 3 and choice == "up": 
            chooser.choice_buf = 6
            chooser.choice_buffer(decision=6)
        elif chooser.choice_buf == 3 and choice == "left": 
            chooser.choice_buf = 2
            chooser.choice_buffer(decision=2)
        elif chooser.choice_buf == 4 and choice == "down": 
            chooser.choice_buf = 1
            chooser.choice_buffer(decision=1)
        elif chooser.choice_buf == 4 and choice == "right": 
            chooser.choice_buf = 5
            chooser.choice_buffer(decision=5)
        elif chooser.choice_buf == 4 and choice == "up": 
            chooser.choice_buf = 7
            chooser.choice_buffer(decision=7)
        elif chooser.choice_buf == 5 and choice == "up": 
            chooser.choice_buf = 8
            chooser.choice_buffer(decision=8)
        elif chooser.choice_buf == 5 and choice == "left": 
            chooser.choice_buf = 4
            chooser.choice_buffer(decision=4)
        elif chooser.choice_buf == 5 and choice == "right": 
            chooser.choice_buf = 6
            chooser.choice_buffer(decision=6)
        elif chooser.choice_buf == 5 and choice == "down": 
            chooser.choice_buf = 2
            chooser.choice_buffer(decision=2)
        elif chooser.choice_buf == 6 and choice == "up": 
            chooser.choice_buf = 9
            chooser.choice_buffer(decision=9)
        elif chooser.choice_buf == 6 and choice == "left": 
            chooser.choice_buf = 5
            chooser.choice_buffer(decision=5)
        elif chooser.choice_buf == 6 and choice == "down": 
            chooser.choice_buf = 3
            chooser.choice_buffer(decision=3)
        elif chooser.choice_buf == 7 and choice == "right": 
            chooser.choice_buf = 8
            chooser.choice_buffer(decision=8)
        elif chooser.choice_buf == 7 and choice == "down": 
            chooser.choice_buf = 4
            chooser.choice_buffer(decision=4)
        elif chooser.choice_buf == 8 and choice == "left": 
            chooser.choice_buf = 7
            chooser.choice_buffer(decision=7)
        elif chooser.choice_buf == 8 and choice == "right": 
            chooser.choice_buf = 9
            chooser.choice_buffer(decision=9)
        elif chooser.choice_buf == 8 and choice == "down": 
            chooser.choice_buf = 5
            chooser.choice_buffer(decision=5)
        elif chooser.choice_buf == 9 and choice == "left": 
            chooser.choice_buf = 8
            chooser.choice_buffer(decision=8)
        elif chooser.choice_buf == 9 and choice == "down": 
            chooser.choice_buf = 6
            chooser.choice_buffer(decision=6)
            
